#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "brfdata.h"
#include "glwidgets.h"
#include "selector.h"
//namespace Ui
//{
//    class MainWindow;
//}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    BrfData brfdata;

 private slots:
    //void newFile();
    void open();
    //void save();
    //void saveAs();
    void openRecentFile();
    void about();

private:
    GLWidget *glWidget;
    Selector *selector;
    QString saveLoadPath;

    void createActions();
    void createMenus();
    void loadFile(const QString &fileName);
    //void saveFile(const QString &fileName);
    void setCurrentFile(const QString &fileName);
    void updateRecentFileActions();
    QString strippedName(const QString &fullFileName);

    QString curFile;

    QMenu *fileMenu;
    QMenu *helpMenu;
    QMenu *recentFilesMenu;
    QAction *openAct;
    //QAction *saveAct;
    //QAction *saveAsAct;
    QAction *exitAct;
    QAction *aboutAct;
    //QAction *aboutQtAct;
    QAction *separatorAct;

    enum { MaxRecentFiles = 10 };
    QAction *recentFileActs[MaxRecentFiles];

    void dragEnterEvent(QDragEnterEvent *event);
    void dropEvent(QDropEvent *event);

};

#endif // MAINWINDOW_H
